﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Xml.Linq;

/// <summary>
/// Summary description for XmlParser
/// </summary>
public static class XmlParser
{

    public static List<Employee> GetAllEmployees(string xmlFilePath)
    {
        try
        {
            List<Employee> employees = new List<Employee>();

            Object obj = new object();
            XDocument document = null;

            lock (obj)
            {
                document = XDocument.Load(xmlFilePath);
            }
            foreach (var element in document.Elements().Elements("employees").Elements("employee"))
            {
                employees.Add(new Employee()
                {
                    Name = element.Element("name").Value,
                    Email = element.Element("email").Value,
                    Level = element.Element("level").Value,
                    Team = element.Element("team").Value,
                    Office = element.Element("office").Value
                });

            }

            return employees;
        }
        catch (Exception)
        {
            throw;
        }

    }

    public static string GetFileOfAllEmployees(string path)
    {
        try
        {
            Object obj = new object();

            lock (obj)
            {
                return XDocument.Load(path).ToString();
            }
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }

    public static XElement LoadFile(string path)
    {
        try
        {
            Object obj = new object();

            lock (obj)
            {
                return XElement.Load(path);
            }
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }

    public static void SaveFile(XElement file, string path)
    {
        try
        {
            Object obj = new object();

            lock (obj)
            {
                file.Save(path);
            }
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
}