﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Xml.Linq;
using Infragistics.Web.UI.GridControls;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        this.WebDataGrid1.Behaviors.EditingCore.RowAdding += new RowAddingHandler(EditingCore_RowAdding);
        this.WebDataGrid1.Behaviors.EditingCore.RowsDeleting += new RowDeletingHandler(EditingCore_RowsDeleting);
        this.WebDataGrid1.Behaviors.EditingCore.RowUpdating += new RowUpdatingHandler(EditingCore_RowUpdating);
            
     
        string path = Server.MapPath(@"App_data\Employees.xml");
            
        this.WebDataGrid1.DataSource = GetAllEmployees(path);                    
    }

    #region CRUD Handlers

    void EditingCore_RowUpdating(object sender, RowUpdatingEventArgs e)
    {
        XElement file = LoadFile(Server.MapPath(@"App_data\Employees.xml"));

        foreach (var item in file.Elements().Elements())
        {
            if (item.Element("email").Value.Trim() == e.Row.Items[1].Value.ToString())
            {
                item.Element("name").Value = e.Values["Name"].ToString();
                item.Element("office").Value = e.Values["Office"].ToString();
                item.Element("email").Value = e.Values["Email"].ToString();
                item.Element("level").Value = e.Values["Level"].ToString();
                item.Element("team").Value = e.Values["Team"].ToString();
            }
        }
        try
        {
            file.Save(Server.MapPath(@"App_data\Employees.xml"));
        }
        catch (Exception)
        {
            throw;
        }
        finally
        {
            string path = Server.MapPath(@"App_data\Employees.xml");
            this.WebDataGrid1.DataSource = GetAllEmployees(path);
            this.WebDataGrid1.DataBind();
        }
    }

    protected void EditingCore_RowsDeleting(object sender, RowDeletingEventArgs e)
    {

        XElement file = LoadFile(Server.MapPath(@"App_data\Employees.xml"));

        foreach (var item in file.Elements().Elements())
        {
            if (item.Element("email").Value.Trim() == e.Row.Items[1].Value.ToString())
            {
                item.Remove();
            }
        }
        try
        {

            file.Save(Server.MapPath(@"App_data\Employees.xml"));

        }
        catch (Exception)
        {
            throw;
        }
        finally
        {

            string path = Server.MapPath(@"App_data\Employees.xml");
            this.WebDataGrid1.DataSource = GetAllEmployees(path);
            this.WebDataGrid1.DataBind();
        }
    }

    void EditingCore_RowAdding(object sender, RowAddingEventArgs e)
    {
        XElement emp = new XElement("employee",
                        new XElement("office", 1),
                        new XElement("name", 2),
                        new XElement("email", 3),
                        new XElement("level", 4),
                        new XElement("team", 5)
        );

        emp.Element("name").Value = e.Values["Name"].ToString();
        emp.Element("office").Value = e.Values["Office"].ToString();
        emp.Element("email").Value = e.Values["Email"].ToString();
        emp.Element("level").Value = e.Values["Level"].ToString();
        emp.Element("team").Value = e.Values["Team"].ToString();

        XElement file = XmlParser.LoadFile(Server.MapPath(@"App_data\Employees.xml"));

        XElement element = new XElement("employee");
        //element.
        file.Element("employees").Add(emp);

        //file.Elements().Elements("employees").First()
        try
        {
            file.Save(Server.MapPath(@"App_data\Employees.xml"));
        }
        catch (Exception)
        {
            throw;
        }
        finally
        {
            string path = Server.MapPath(@"App_data\Employees.xml");
            this.WebDataGrid1.DataSource = GetAllEmployees(path);
            this.WebDataGrid1.DataBind();
        }
    }


    #endregion

    #region Utill
    
    public static List<Employee> GetAllEmployees(string xmlFilePath)
    {
        try
        {
            List<Employee> employees = new List<Employee>();

            Object obj = new object();
            XDocument document = null;

            lock (obj)
            {
                document = XDocument.Load(xmlFilePath);
            }
            foreach (var element in document.Elements().Elements("employees").Elements("employee"))
            {
                employees.Add(new Employee()
                {
                    Name = element.Element("name").Value,
                    Email = element.Element("email").Value,
                    Level = element.Element("level").Value,
                    Team = element.Element("team").Value,
                    Office = element.Element("office").Value
                });

            }

            return employees;
        }
        catch (Exception)
        {
            throw;
        }

    }

    public static string GetFileOfAllEmployees(string path)
    {
        try
        {

            Object obj = new object();

            lock (obj)
            {
                return XDocument.Load(path).ToString();
            }

        }
        catch (Exception)
        {
            throw;
        }
    }

    public static XElement LoadFile(string path)
    {
        try
        {
            Object obj = new object();

            lock (obj)
            {
                return XElement.Load(path);
            }
        }
        catch (Exception)
        {
            throw;
        }
    }

    public static void SaveFile(XElement file, string path)
    {
        try
        {
            Object obj = new object();

            lock (obj)
            {
                file.Save(path);
            }
        }
        catch (Exception)
        {
            throw;
        }
    }   

    #endregion

}